SystemOrganization addCategory: #'GBT-DSL_Forum'!

Object subclass: #GbtForumA
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_Forum'!

!GbtForumA class methodsFor: 'example' stamp: 'CC 1/15/2017 20:24'!
exampleClear
	GbtStore clearStore. 
	GbtSVO initialize. ! !

!GbtForumA class methodsFor: 'example' stamp: 'CC 1/18/2017 14:12'!
exampleRun
	(self new forumAApp: '') open! !

!GbtForumA methodsFor: 'things' stamp: 'CC 1/18/2017 16:11'!
forumA
	"self new forumA edit"
	
	^GbtThing newStruct: 'ForumA' define: {
		{ #Name . #val: . 'forum 1'}.
		{ #threads . #listOf: . self threadA}.
	} full: { 
		{ #category . #val: . 'cat 1'}.
		{ #threadCount .  #no: . 0}.
		{ #messageCount .  #no: . 0}.
		{ #viewCount .  #no: . 0}.
	}! !

!GbtForumA methodsFor: 'contexts' stamp: 'CC 1/18/2017 14:01'!
forumA: userName  
	"(self new forumA: '' ) open" 

	^GbtBigListAC newStruct: 'ForumA'  for: userName define: {
		{#displayAs: . 'ForumList'} .
		{#noPolicyPrefix: . 'Forum'}.
		{#uiSpec:icon: . #GbtListAndItemUI . #contacts} .
		{#templates: . self forumA} .
		{#loadPolicy: . #autoload } .
		{#display: . #(#(forumName ForumName)  category threads messages views)} .
		{#subcontext: . self ForumAItemContext: userName}}! !

!GbtForumA methodsFor: 'contexts' stamp: 'CC 1/18/2017 14:09'!
forumAApp: userName  
	"(self new forumAApp: '' ) open" 

	^GbtPlainAC newStruct: 'ForumAApp'  for: userName define: {
		{#aspect:on: . self forumAListCtx: userName . #customer  } .
		{#uiSpec:icon: . #GbtMainUI . #walletBig} .
		{#extent: . (800 @ 600)}.
	}! !

!GbtForumA methodsFor: 'contexts' stamp: 'CC 1/18/2017 15:51'!
forumAItemCtx: userName  
	^GbtPlainAC newStruct: 'ForumAItemContext'  for: userName define: {
		{#displayAs: . 'a Forum'  } .
		{#uiSpec:icon: . #GbtItemWithTabsUI . #contacts }.
		{#aspect:on: . self threadsACtx: userName . #contacts } .
	}! !

!GbtForumA methodsFor: 'contexts' stamp: 'CC 1/18/2017 15:04'!
forumAListCtx: userName  
	"(self new forumA: '' ) open" 

	^GbtBigListAC newStruct: 'ForumAList'  for: userName define: {
		{#displayAs: . 'ForumAList'} .
		{#noPolicyPrefix: . 'Forum'}.
		{#uiSpec:icon: . #GbtListAndItemUI . #contacts} .
		{#templates: . self forumA} .
		{#loadPolicy: . #autoload } .
		{#display: . #(#(Name forumName)  category threads messages views)} .
		{#subcontext: . self forumAItemCtx: userName}}! !

!GbtForumA methodsFor: 'things' stamp: 'CC 1/18/2017 13:48'!
replyA
	"self new replyA edit"
	
	^GbtThing newStruct: 'ReplyA' define: {
		{ #Id . #val: . ''}.
		{ #ReplyDataTime . #val: . ''}.
	} full: { 
		{ #PostedBy . #val: . ''}.
		{ #Message .  #val: . ''}.
	}! !

!GbtForumA methodsFor: 'things' stamp: 'CC 1/18/2017 16:22'!
threadA
	"self threadA edit"
	^GbtThing newStruct: 'ThreadA' define: {
		{ #ForumName . #ref: . '#Name'}.
		{ #Subject . #val: . ''}.
		{ #Replies . #listOf: . self replyA}.
	} full: { 
		{ #LastPostedBy . #val: . ''}.
		{ #Message .  #val: . ''}.
		{ #replies .  #no: . 0}.
		{ #views .  #no: . 0}.
	}! !

!GbtForumA methodsFor: 'contexts' stamp: 'CC 1/18/2017 16:16'!
threadACtx: userName  
	^GbtPlainAC newStruct: 'ThreadAContext'  for: userName define: {
		{#displayAs: . 'thread'  } .
		{#uiSpec:icon: . #GbtItemUI . #contacts}.
	}! !

!GbtForumA methodsFor: 'contexts' stamp: 'CC 1/18/2017 16:28'!
threadsACtx: userName  
	^GbtUlistAC newStruct: 'ThreadsAContext'  for: userName define: {
		{#displayAs: . 'discussion threads'  } .
		{#noPolicyPrefix: . 'Thread'}.
		{#template:for: . self threadA . #threads }.
		{ #subcontext: . self threadACtx: userName }.
		{#uiSpec:icon: . #GbtListAndItemUI . #contacts}.
	}! !

Object subclass: #GbtForumB
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_Forum'!
